<?php

namespace Sura\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfArchivoAdjuntosModel ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfArchivoAdjuntosModel
 * @subpackage Arrays
 */
class ArrayOfArchivoAdjuntosModel extends AbstractStructArrayBase
{
    /**
     * The ArchivoAdjuntosModel
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\ArchivoAdjuntosModel[]
     */
    public $ArchivoAdjuntosModel;
    /**
     * Constructor method for ArrayOfArchivoAdjuntosModel
     * @uses ArrayOfArchivoAdjuntosModel::setArchivoAdjuntosModel()
     * @param \Sura\Autoclick\StructType\ArchivoAdjuntosModel[] $archivoAdjuntosModel
     */
    public function __construct(array $archivoAdjuntosModel = array())
    {
        $this
            ->setArchivoAdjuntosModel($archivoAdjuntosModel);
    }
    /**
     * Get ArchivoAdjuntosModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\ArchivoAdjuntosModel[]|null
     */
    public function getArchivoAdjuntosModel()
    {
        return isset($this->ArchivoAdjuntosModel) ? $this->ArchivoAdjuntosModel : null;
    }
    /**
     * Set ArchivoAdjuntosModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\ArchivoAdjuntosModel[] $archivoAdjuntosModel
     * @return \Sura\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel
     */
    public function setArchivoAdjuntosModel(array $archivoAdjuntosModel = array())
    {
        foreach ($archivoAdjuntosModel as $arrayOfArchivoAdjuntosModelArchivoAdjuntosModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfArchivoAdjuntosModelArchivoAdjuntosModelItem instanceof \Sura\Autoclick\StructType\ArchivoAdjuntosModel) {
                throw new \InvalidArgumentException(sprintf('The ArchivoAdjuntosModel property can only contain items of \Sura\Autoclick\StructType\ArchivoAdjuntosModel, "%s" given', is_object($arrayOfArchivoAdjuntosModelArchivoAdjuntosModelItem) ? get_class($arrayOfArchivoAdjuntosModelArchivoAdjuntosModelItem) : gettype($arrayOfArchivoAdjuntosModelArchivoAdjuntosModelItem)), __LINE__);
            }
        }
        if (is_null($archivoAdjuntosModel) || (is_array($archivoAdjuntosModel) && empty($archivoAdjuntosModel))) {
            unset($this->ArchivoAdjuntosModel);
        } else {
            $this->ArchivoAdjuntosModel = $archivoAdjuntosModel;
        }
        return $this;
    }
    /**
     * Add item to ArchivoAdjuntosModel value
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\ArchivoAdjuntosModel $item
     * @return \Sura\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel
     */
    public function addToArchivoAdjuntosModel(\Sura\Autoclick\StructType\ArchivoAdjuntosModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Autoclick\StructType\ArchivoAdjuntosModel) {
            throw new \InvalidArgumentException(sprintf('The ArchivoAdjuntosModel property can only contain items of \Sura\Autoclick\StructType\ArchivoAdjuntosModel, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ArchivoAdjuntosModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Autoclick\StructType\ArchivoAdjuntosModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Autoclick\StructType\ArchivoAdjuntosModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Autoclick\StructType\ArchivoAdjuntosModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Autoclick\StructType\ArchivoAdjuntosModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Autoclick\StructType\ArchivoAdjuntosModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ArchivoAdjuntosModel
     */
    public function getAttributeName()
    {
        return 'ArchivoAdjuntosModel';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\ArrayType\ArrayOfArchivoAdjuntosModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
