<?php

namespace Sura\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducible ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducible
 * @subpackage Arrays
 */
class ArrayOfDeducible extends AbstractStructArrayBase
{
    /**
     * The Deducible
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\Deducible[]
     */
    public $Deducible;
    /**
     * Constructor method for ArrayOfDeducible
     * @uses ArrayOfDeducible::setDeducible()
     * @param \Sura\Autoclick\StructType\Deducible[] $deducible
     */
    public function __construct(array $deducible = array())
    {
        $this
            ->setDeducible($deducible);
    }
    /**
     * Get Deducible value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\Deducible[]|null
     */
    public function getDeducible()
    {
        return isset($this->Deducible) ? $this->Deducible : null;
    }
    /**
     * Set Deducible value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\Deducible[] $deducible
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducible
     */
    public function setDeducible(array $deducible = array())
    {
        foreach ($deducible as $arrayOfDeducibleDeducibleItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleDeducibleItem instanceof \Sura\Autoclick\StructType\Deducible) {
                throw new \InvalidArgumentException(sprintf('The Deducible property can only contain items of \Sura\Autoclick\StructType\Deducible, "%s" given', is_object($arrayOfDeducibleDeducibleItem) ? get_class($arrayOfDeducibleDeducibleItem) : gettype($arrayOfDeducibleDeducibleItem)), __LINE__);
            }
        }
        if (is_null($deducible) || (is_array($deducible) && empty($deducible))) {
            unset($this->Deducible);
        } else {
            $this->Deducible = $deducible;
        }
        return $this;
    }
    /**
     * Add item to Deducible value
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\Deducible $item
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducible
     */
    public function addToDeducible(\Sura\Autoclick\StructType\Deducible $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Autoclick\StructType\Deducible) {
            throw new \InvalidArgumentException(sprintf('The Deducible property can only contain items of \Sura\Autoclick\StructType\Deducible, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Deducible[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Autoclick\StructType\Deducible|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Autoclick\StructType\Deducible|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Autoclick\StructType\Deducible|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Autoclick\StructType\Deducible|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Autoclick\StructType\Deducible|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Deducible
     */
    public function getAttributeName()
    {
        return 'Deducible';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducible
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
