<?php

namespace Sura\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducibleCobertura ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducibleCobertura
 * @subpackage Arrays
 */
class ArrayOfDeducibleCobertura extends AbstractStructArrayBase
{
    /**
     * The DeducibleCobertura
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\DeducibleCobertura[]
     */
    public $DeducibleCobertura;
    /**
     * Constructor method for ArrayOfDeducibleCobertura
     * @uses ArrayOfDeducibleCobertura::setDeducibleCobertura()
     * @param \Sura\Autoclick\StructType\DeducibleCobertura[] $deducibleCobertura
     */
    public function __construct(array $deducibleCobertura = array())
    {
        $this
            ->setDeducibleCobertura($deducibleCobertura);
    }
    /**
     * Get DeducibleCobertura value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\DeducibleCobertura[]|null
     */
    public function getDeducibleCobertura()
    {
        return isset($this->DeducibleCobertura) ? $this->DeducibleCobertura : null;
    }
    /**
     * Set DeducibleCobertura value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\DeducibleCobertura[] $deducibleCobertura
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleCobertura
     */
    public function setDeducibleCobertura(array $deducibleCobertura = array())
    {
        foreach ($deducibleCobertura as $arrayOfDeducibleCoberturaDeducibleCoberturaItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleCoberturaDeducibleCoberturaItem instanceof \Sura\Autoclick\StructType\DeducibleCobertura) {
                throw new \InvalidArgumentException(sprintf('The DeducibleCobertura property can only contain items of \Sura\Autoclick\StructType\DeducibleCobertura, "%s" given', is_object($arrayOfDeducibleCoberturaDeducibleCoberturaItem) ? get_class($arrayOfDeducibleCoberturaDeducibleCoberturaItem) : gettype($arrayOfDeducibleCoberturaDeducibleCoberturaItem)), __LINE__);
            }
        }
        if (is_null($deducibleCobertura) || (is_array($deducibleCobertura) && empty($deducibleCobertura))) {
            unset($this->DeducibleCobertura);
        } else {
            $this->DeducibleCobertura = $deducibleCobertura;
        }
        return $this;
    }
    /**
     * Add item to DeducibleCobertura value
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\DeducibleCobertura $item
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleCobertura
     */
    public function addToDeducibleCobertura(\Sura\Autoclick\StructType\DeducibleCobertura $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Autoclick\StructType\DeducibleCobertura) {
            throw new \InvalidArgumentException(sprintf('The DeducibleCobertura property can only contain items of \Sura\Autoclick\StructType\DeducibleCobertura, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DeducibleCobertura[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Autoclick\StructType\DeducibleCobertura|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Autoclick\StructType\DeducibleCobertura|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Autoclick\StructType\DeducibleCobertura|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Autoclick\StructType\DeducibleCobertura|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Autoclick\StructType\DeducibleCobertura|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeducibleCobertura
     */
    public function getAttributeName()
    {
        return 'DeducibleCobertura';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleCobertura
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
