<?php

namespace Sura\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducibleCoberturaModel ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducibleCoberturaModel
 * @subpackage Arrays
 */
class ArrayOfDeducibleCoberturaModel extends AbstractStructArrayBase
{
    /**
     * The DeducibleCoberturaModel
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\DeducibleCoberturaModel[]
     */
    public $DeducibleCoberturaModel;
    /**
     * Constructor method for ArrayOfDeducibleCoberturaModel
     * @uses ArrayOfDeducibleCoberturaModel::setDeducibleCoberturaModel()
     * @param \Sura\Autoclick\StructType\DeducibleCoberturaModel[] $deducibleCoberturaModel
     */
    public function __construct(array $deducibleCoberturaModel = array())
    {
        $this
            ->setDeducibleCoberturaModel($deducibleCoberturaModel);
    }
    /**
     * Get DeducibleCoberturaModel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\DeducibleCoberturaModel[]|null
     */
    public function getDeducibleCoberturaModel()
    {
        return isset($this->DeducibleCoberturaModel) ? $this->DeducibleCoberturaModel : null;
    }
    /**
     * Set DeducibleCoberturaModel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\DeducibleCoberturaModel[] $deducibleCoberturaModel
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleCoberturaModel
     */
    public function setDeducibleCoberturaModel(array $deducibleCoberturaModel = array())
    {
        foreach ($deducibleCoberturaModel as $arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem instanceof \Sura\Autoclick\StructType\DeducibleCoberturaModel) {
                throw new \InvalidArgumentException(sprintf('The DeducibleCoberturaModel property can only contain items of \Sura\Autoclick\StructType\DeducibleCoberturaModel, "%s" given', is_object($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem) ? get_class($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem) : gettype($arrayOfDeducibleCoberturaModelDeducibleCoberturaModelItem)), __LINE__);
            }
        }
        if (is_null($deducibleCoberturaModel) || (is_array($deducibleCoberturaModel) && empty($deducibleCoberturaModel))) {
            unset($this->DeducibleCoberturaModel);
        } else {
            $this->DeducibleCoberturaModel = $deducibleCoberturaModel;
        }
        return $this;
    }
    /**
     * Add item to DeducibleCoberturaModel value
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\DeducibleCoberturaModel $item
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleCoberturaModel
     */
    public function addToDeducibleCoberturaModel(\Sura\Autoclick\StructType\DeducibleCoberturaModel $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Autoclick\StructType\DeducibleCoberturaModel) {
            throw new \InvalidArgumentException(sprintf('The DeducibleCoberturaModel property can only contain items of \Sura\Autoclick\StructType\DeducibleCoberturaModel, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DeducibleCoberturaModel[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Autoclick\StructType\DeducibleCoberturaModel|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeducibleCoberturaModel
     */
    public function getAttributeName()
    {
        return 'DeducibleCoberturaModel';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleCoberturaModel
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
