<?php

namespace Sura\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDeducibleKilometro ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDeducibleKilometro
 * @subpackage Arrays
 */
class ArrayOfDeducibleKilometro extends AbstractStructArrayBase
{
    /**
     * The DeducibleKilometro
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\DeducibleKilometro[]
     */
    public $DeducibleKilometro;
    /**
     * Constructor method for ArrayOfDeducibleKilometro
     * @uses ArrayOfDeducibleKilometro::setDeducibleKilometro()
     * @param \Sura\Autoclick\StructType\DeducibleKilometro[] $deducibleKilometro
     */
    public function __construct(array $deducibleKilometro = array())
    {
        $this
            ->setDeducibleKilometro($deducibleKilometro);
    }
    /**
     * Get DeducibleKilometro value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\DeducibleKilometro[]|null
     */
    public function getDeducibleKilometro()
    {
        return isset($this->DeducibleKilometro) ? $this->DeducibleKilometro : null;
    }
    /**
     * Set DeducibleKilometro value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\DeducibleKilometro[] $deducibleKilometro
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro
     */
    public function setDeducibleKilometro(array $deducibleKilometro = array())
    {
        foreach ($deducibleKilometro as $arrayOfDeducibleKilometroDeducibleKilometroItem) {
            // validation for constraint: itemType
            if (!$arrayOfDeducibleKilometroDeducibleKilometroItem instanceof \Sura\Autoclick\StructType\DeducibleKilometro) {
                throw new \InvalidArgumentException(sprintf('The DeducibleKilometro property can only contain items of \Sura\Autoclick\StructType\DeducibleKilometro, "%s" given', is_object($arrayOfDeducibleKilometroDeducibleKilometroItem) ? get_class($arrayOfDeducibleKilometroDeducibleKilometroItem) : gettype($arrayOfDeducibleKilometroDeducibleKilometroItem)), __LINE__);
            }
        }
        if (is_null($deducibleKilometro) || (is_array($deducibleKilometro) && empty($deducibleKilometro))) {
            unset($this->DeducibleKilometro);
        } else {
            $this->DeducibleKilometro = $deducibleKilometro;
        }
        return $this;
    }
    /**
     * Add item to DeducibleKilometro value
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\DeducibleKilometro $item
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro
     */
    public function addToDeducibleKilometro(\Sura\Autoclick\StructType\DeducibleKilometro $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Autoclick\StructType\DeducibleKilometro) {
            throw new \InvalidArgumentException(sprintf('The DeducibleKilometro property can only contain items of \Sura\Autoclick\StructType\DeducibleKilometro, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DeducibleKilometro[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Autoclick\StructType\DeducibleKilometro|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Autoclick\StructType\DeducibleKilometro|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Autoclick\StructType\DeducibleKilometro|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Autoclick\StructType\DeducibleKilometro|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Autoclick\StructType\DeducibleKilometro|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeducibleKilometro
     */
    public function getAttributeName()
    {
        return 'DeducibleKilometro';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
