<?php

namespace Sura\Autoclick\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOfertaBase ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOfertaBase
 * @subpackage Arrays
 */
class ArrayOfOfertaBase extends AbstractStructArrayBase
{
    /**
     * The OfertaBase
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\OfertaBase[]
     */
    public $OfertaBase;
    /**
     * Constructor method for ArrayOfOfertaBase
     * @uses ArrayOfOfertaBase::setOfertaBase()
     * @param \Sura\Autoclick\StructType\OfertaBase[] $ofertaBase
     */
    public function __construct(array $ofertaBase = array())
    {
        $this
            ->setOfertaBase($ofertaBase);
    }
    /**
     * Get OfertaBase value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\OfertaBase[]|null
     */
    public function getOfertaBase()
    {
        return isset($this->OfertaBase) ? $this->OfertaBase : null;
    }
    /**
     * Set OfertaBase value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\OfertaBase[] $ofertaBase
     * @return \Sura\Autoclick\ArrayType\ArrayOfOfertaBase
     */
    public function setOfertaBase(array $ofertaBase = array())
    {
        foreach ($ofertaBase as $arrayOfOfertaBaseOfertaBaseItem) {
            // validation for constraint: itemType
            if (!$arrayOfOfertaBaseOfertaBaseItem instanceof \Sura\Autoclick\StructType\OfertaBase) {
                throw new \InvalidArgumentException(sprintf('The OfertaBase property can only contain items of \Sura\Autoclick\StructType\OfertaBase, "%s" given', is_object($arrayOfOfertaBaseOfertaBaseItem) ? get_class($arrayOfOfertaBaseOfertaBaseItem) : gettype($arrayOfOfertaBaseOfertaBaseItem)), __LINE__);
            }
        }
        if (is_null($ofertaBase) || (is_array($ofertaBase) && empty($ofertaBase))) {
            unset($this->OfertaBase);
        } else {
            $this->OfertaBase = $ofertaBase;
        }
        return $this;
    }
    /**
     * Add item to OfertaBase value
     * @throws \InvalidArgumentException
     * @param \Sura\Autoclick\StructType\OfertaBase $item
     * @return \Sura\Autoclick\ArrayType\ArrayOfOfertaBase
     */
    public function addToOfertaBase(\Sura\Autoclick\StructType\OfertaBase $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \Sura\Autoclick\StructType\OfertaBase) {
            throw new \InvalidArgumentException(sprintf('The OfertaBase property can only contain items of \Sura\Autoclick\StructType\OfertaBase, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OfertaBase[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \Sura\Autoclick\StructType\OfertaBase|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \Sura\Autoclick\StructType\OfertaBase|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \Sura\Autoclick\StructType\OfertaBase|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \Sura\Autoclick\StructType\OfertaBase|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \Sura\Autoclick\StructType\OfertaBase|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OfertaBase
     */
    public function getAttributeName()
    {
        return 'OfertaBase';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\ArrayType\ArrayOfOfertaBase
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
