<?php

namespace Sura\Autoclick\EnumType;

/**
 * This class stands for OpcionalAutoReemplazo EnumType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OpcionalAutoReemplazo
 * @subpackage Enumerations
 */
class OpcionalAutoReemplazo
{
    /**
     * Constant for value 'TreintaDias'
     * @return string 'TreintaDias'
     */
    const VALUE_TREINTA_DIAS = 'TreintaDias';
    /**
     * Constant for value 'CuarentayCincoDias'
     * @return string 'CuarentayCincoDias'
     */
    const VALUE_CUARENTAY_CINCO_DIAS = 'CuarentayCincoDias';
    /**
     * Constant for value 'Ilimitado'
     * @return string 'Ilimitado'
     */
    const VALUE_ILIMITADO = 'Ilimitado';
    /**
     * Constant for value 'SinOpcional'
     * @return string 'SinOpcional'
     */
    const VALUE_SIN_OPCIONAL = 'SinOpcional';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_TREINTA_DIAS
     * @uses self::VALUE_CUARENTAY_CINCO_DIAS
     * @uses self::VALUE_ILIMITADO
     * @uses self::VALUE_SIN_OPCIONAL
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_TREINTA_DIAS,
            self::VALUE_CUARENTAY_CINCO_DIAS,
            self::VALUE_ILIMITADO,
            self::VALUE_SIN_OPCIONAL,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
