<?php

namespace Sura\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsultaPlanPagoResponse StructType
 * @subpackage Structs
 */
class ConsultaPlanPagoResponse extends AbstractStructBase
{
    /**
     * The Fault
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\Fault
     */
    public $Fault;
    /**
     * The PlanPago
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\StructType\PlanPagoModel
     */
    public $PlanPago;
    /**
     * Constructor method for ConsultaPlanPagoResponse
     * @uses ConsultaPlanPagoResponse::setFault()
     * @uses ConsultaPlanPagoResponse::setPlanPago()
     * @param \Sura\Autoclick\StructType\Fault $fault
     * @param \Sura\Autoclick\StructType\PlanPagoModel $planPago
     */
    public function __construct(\Sura\Autoclick\StructType\Fault $fault = null, \Sura\Autoclick\StructType\PlanPagoModel $planPago = null)
    {
        $this
            ->setFault($fault)
            ->setPlanPago($planPago);
    }
    /**
     * Get Fault value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\Fault|null
     */
    public function getFault()
    {
        return isset($this->Fault) ? $this->Fault : null;
    }
    /**
     * Set Fault value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Autoclick\StructType\Fault $fault
     * @return \Sura\Autoclick\StructType\ConsultaPlanPagoResponse
     */
    public function setFault(\Sura\Autoclick\StructType\Fault $fault = null)
    {
        if (is_null($fault) || (is_array($fault) && empty($fault))) {
            unset($this->Fault);
        } else {
            $this->Fault = $fault;
        }
        return $this;
    }
    /**
     * Get PlanPago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\StructType\PlanPagoModel|null
     */
    public function getPlanPago()
    {
        return isset($this->PlanPago) ? $this->PlanPago : null;
    }
    /**
     * Set PlanPago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Autoclick\StructType\PlanPagoModel $planPago
     * @return \Sura\Autoclick\StructType\ConsultaPlanPagoResponse
     */
    public function setPlanPago(\Sura\Autoclick\StructType\PlanPagoModel $planPago = null)
    {
        if (is_null($planPago) || (is_array($planPago) && empty($planPago))) {
            unset($this->PlanPago);
        } else {
            $this->PlanPago = $planPago;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\StructType\ConsultaPlanPagoResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
