<?php

namespace Sura\Autoclick\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OfertaKilometro StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:OfertaKilometro
 * @subpackage Structs
 */
class OfertaKilometro extends AbstractStructBase
{
    /**
     * The Deducibles
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro
     */
    public $Deducibles;
    /**
     * The FormasDePago
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\ArrayType\ArrayOfFormaPago
     */
    public $FormasDePago;
    /**
     * The Opcionales
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \Sura\Autoclick\ArrayType\ArrayOfOpcional
     */
    public $Opcionales;
    /**
     * The codigoProducto
     * @var int
     */
    public $codigoProducto;
    /**
     * The producto
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $producto;
    /**
     * Constructor method for OfertaKilometro
     * @uses OfertaKilometro::setDeducibles()
     * @uses OfertaKilometro::setFormasDePago()
     * @uses OfertaKilometro::setOpcionales()
     * @uses OfertaKilometro::setCodigoProducto()
     * @uses OfertaKilometro::setProducto()
     * @param \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro $deducibles
     * @param \Sura\Autoclick\ArrayType\ArrayOfFormaPago $formasDePago
     * @param \Sura\Autoclick\ArrayType\ArrayOfOpcional $opcionales
     * @param int $codigoProducto
     * @param string $producto
     */
    public function __construct(\Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro $deducibles = null, \Sura\Autoclick\ArrayType\ArrayOfFormaPago $formasDePago = null, \Sura\Autoclick\ArrayType\ArrayOfOpcional $opcionales = null, $codigoProducto = null, $producto = null)
    {
        $this
            ->setDeducibles($deducibles)
            ->setFormasDePago($formasDePago)
            ->setOpcionales($opcionales)
            ->setCodigoProducto($codigoProducto)
            ->setProducto($producto);
    }
    /**
     * Get Deducibles value
     * @return \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro|null
     */
    public function getDeducibles()
    {
        return $this->Deducibles;
    }
    /**
     * Set Deducibles value
     * @param \Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro $deducibles
     * @return \Sura\Autoclick\StructType\OfertaKilometro
     */
    public function setDeducibles(\Sura\Autoclick\ArrayType\ArrayOfDeducibleKilometro $deducibles = null)
    {
        $this->Deducibles = $deducibles;
        return $this;
    }
    /**
     * Get FormasDePago value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\ArrayType\ArrayOfFormaPago|null
     */
    public function getFormasDePago()
    {
        return isset($this->FormasDePago) ? $this->FormasDePago : null;
    }
    /**
     * Set FormasDePago value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Autoclick\ArrayType\ArrayOfFormaPago $formasDePago
     * @return \Sura\Autoclick\StructType\OfertaKilometro
     */
    public function setFormasDePago(\Sura\Autoclick\ArrayType\ArrayOfFormaPago $formasDePago = null)
    {
        if (is_null($formasDePago) || (is_array($formasDePago) && empty($formasDePago))) {
            unset($this->FormasDePago);
        } else {
            $this->FormasDePago = $formasDePago;
        }
        return $this;
    }
    /**
     * Get Opcionales value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \Sura\Autoclick\ArrayType\ArrayOfOpcional|null
     */
    public function getOpcionales()
    {
        return isset($this->Opcionales) ? $this->Opcionales : null;
    }
    /**
     * Set Opcionales value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \Sura\Autoclick\ArrayType\ArrayOfOpcional $opcionales
     * @return \Sura\Autoclick\StructType\OfertaKilometro
     */
    public function setOpcionales(\Sura\Autoclick\ArrayType\ArrayOfOpcional $opcionales = null)
    {
        if (is_null($opcionales) || (is_array($opcionales) && empty($opcionales))) {
            unset($this->Opcionales);
        } else {
            $this->Opcionales = $opcionales;
        }
        return $this;
    }
    /**
     * Get codigoProducto value
     * @return int|null
     */
    public function getCodigoProducto()
    {
        return $this->codigoProducto;
    }
    /**
     * Set codigoProducto value
     * @param int $codigoProducto
     * @return \Sura\Autoclick\StructType\OfertaKilometro
     */
    public function setCodigoProducto($codigoProducto = null)
    {
        // validation for constraint: int
        if (!is_null($codigoProducto) && !is_numeric($codigoProducto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($codigoProducto)), __LINE__);
        }
        $this->codigoProducto = $codigoProducto;
        return $this;
    }
    /**
     * Get producto value
     * @return string|null
     */
    public function getProducto()
    {
        return $this->producto;
    }
    /**
     * Set producto value
     * @param string $producto
     * @return \Sura\Autoclick\StructType\OfertaKilometro
     */
    public function setProducto($producto = null)
    {
        // validation for constraint: string
        if (!is_null($producto) && !is_string($producto)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($producto)), __LINE__);
        }
        $this->producto = $producto;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Sura\Autoclick\StructType\OfertaKilometro
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
